package com.smcic.api.admin.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.smcic.api.admin.dto.NamePageDTO;
import com.smcic.api.admin.entity.LifeService;
import com.smcic.api.admin.service.impl.LifeServiceServiceImpl;
import com.smcic.core.auth.LoginRequired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author syj
 * @since 2023-11-16
 */
@RestController
@RequestMapping("/admin/life-service")
public class LifeServiceController {
    @Resource
    private LifeServiceServiceImpl lifeServiceService;

    @PostMapping("/add")
    @LoginRequired
    public void add(@RequestBody LifeService lifeService) {
        lifeServiceService.add(lifeService);
    }

    @RequestMapping("/list")
    @LoginRequired
    public Page<LifeService> list(@RequestBody NamePageDTO namePageDTO) {
        return lifeServiceService.listByPage(namePageDTO);
    }

    @PostMapping("/update")
    @LoginRequired
    public void update(@RequestBody LifeService lifeService) {
        lifeServiceService.update(lifeService);
    }

    @DeleteMapping("/delete/{id}")
    @LoginRequired
    public void delete(@PathVariable Long id) {
        lifeServiceService.delete(id);
    }
}
