package com.smcic.api.admin.controller;


import com.smcic.api.admin.entity.LiveStream;
import com.smcic.api.admin.service.impl.LiveStreamServiceImpl;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * <p>
 * 电视广播直播流地址管理 前端控制器
 * </p>
 *
 * @author syj
 * @since 2023-11-16
 */
@RestController
@RequestMapping("/admin/live-stream")
public class LiveStreamController {

    @Resource
    private LiveStreamServiceImpl liveStreamService;

    @RequestMapping("/list")
    public List<LiveStream> list() {
        return liveStreamService.list();
    }

    @PostMapping("/add")
    public void add(@RequestBody LiveStream liveStream) {
        liveStreamService.add(liveStream);
    }

    @PostMapping("/update")
    public void update(@RequestBody LiveStream liveStream) {
        liveStreamService.update(liveStream);
    }

    @DeleteMapping("/delete/{id}")
    public void delete(@PathVariable Long id) {
        liveStreamService.delete(id);
    }


}
