package com.smcic.api.admin.dto;

import com.smcic.api.admin.entity.MenuModule;
import com.smcic.api.admin.entity.UserRole;
import com.smcic.core.advice.APIException;
import lombok.Data;

import java.io.Serializable;
import java.util.List;
import java.util.stream.Collectors;

@Data
public class UserRoleDTO implements Serializable {
    private Long roleId;

    private String name;

    private String remark;

    private List<MenuModule> modules;

    public UserRole userRole(){
        UserRole userRole = new UserRole();
        userRole.setRoleId(this.roleId);
        userRole.setName(this.name);
        userRole.setRemark(this.remark);
        try {
            userRole.setModuleIds(this.modules.stream().map(mo -> String.valueOf(mo.getModuleId())).collect(Collectors.joining(",")));
        } catch (Exception e) {
            throw new APIException("菜单参数错误");
        }
        return userRole;

    }

}
