package com.smcic.api.admin.service.impl;

import cn.hutool.core.date.DateTime;
import com.smcic.api.admin.entity.NetworkMedia;
import com.smcic.api.admin.mapper.NetworkMediaMapper;
import com.smcic.api.admin.service.INetworkMediaService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.smcic.api.admin.service.OSSService;
import com.smcic.core.advice.APIException;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.util.List;
import java.util.Random;

/**
 * <p>
 * 网媒管理 服务实现类
 * </p>
 *
 * @author syj
 * @since 2023-11-16
 */
@Service
public class NetworkMediaServiceImpl extends ServiceImpl<NetworkMediaMapper, NetworkMedia> implements INetworkMediaService {

    @Resource
    private OSSService ossService;

    public String upload(MultipartFile file){
        if(null == file){
            throw new APIException("文件为空");
        }
        Random random = new Random();
        String path = "neican/img/networkmedia/" + (new DateTime().toString("yyyyMMddHHmmss"))+"/" + random.nextInt() + "-" + file.getOriginalFilename();
        ossService.put("smcic-index", path, file);
        return  "https://cxzx.smcic.net/" + path;
    }
    public void add(NetworkMedia networkMedia) {
        networkMedia.setStatus(0);
        save(networkMedia);
    }

    public void update(NetworkMedia networkMedia) {
        NetworkMedia nm = getById(networkMedia.getMediaId());
        if (nm == null){
            throw new APIException("不存在的网媒");
        }
        networkMedia.setStatus(0);
        updateById(networkMedia);
    }

}
