package com.smcic.api.admin.service.impl;

import com.smcic.api.admin.entity.Organ;
import com.smcic.api.admin.entity.RoleAclData;
import com.smcic.api.admin.entity.Users;
import com.smcic.api.admin.mapper.RoleAclDataMapper;
import com.smcic.api.admin.service.IRoleAclDataService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 * 角色数据权限表 服务实现类
 * </p>
 *
 * @author syj
 * @since 2023-11-16
 */
@Service
public class RoleAclDataServiceImpl extends ServiceImpl<RoleAclDataMapper, RoleAclData> implements IRoleAclDataService {

    @Resource
    private OrganServiceImpl organService;

    @Resource
    private UsersServiceImpl usersService;

    public List<Organ> getOrgan(Long roleId) {
        List<RoleAclData> roleAclDataList = lambdaQuery().eq(RoleAclData::getRoleId, roleId).list();

        List<Long> organIds = roleAclDataList.stream().map(RoleAclData::getOrganId).distinct().collect(Collectors.toList());

        List<Organ> organs;

        if(organIds.contains(-1L)){
            organs = organService.list();
        }else{
            organs = organService.lambdaQuery().in(Organ::getOrganId, organIds).list();
        }

        Map<Long, Organ> organMap = organs.stream().collect(Collectors.toMap(Organ::getOrganId, organ -> organ));

        List<Users> users;
        List<Long> uids = roleAclDataList.stream().map(RoleAclData::getUserId).distinct().collect(Collectors.toList());
        if(uids.contains(-1L)){
            users = usersService.list();
        }else{
            users = usersService.lambdaQuery().in(Users::getUserId, uids).list();
        }

        for (Users user : users) {
            organMap.get(user.getOrganId()).getUsers().add(user);
        }

        return organs;
    }
}
